;=============[ USART.ASM ]==========================[ 12-14-2002 ]==;
; (C) 2002 Jerry Han
; Protected under the GNU General Public License
; for specific license information, see www.gnu.org/copyleft/gpl.html
;
; version 1.00 PRERELEASE
;
; This piece of software is designed to run on a PIC (16F628 or equivalent)
; and connect to a standard (Hitachi 44780-based) LCD/VFD or similar display.
;
; It provides an RS-232 interface on which it received commands for
; the display.  It attempts to emulate the Matrix-Orbital serial display
; command set.
;
; ============================================================================
; This file contain USART/RS232 Service and routines
;
;**********************************************
; USART˫ͨ
; USART1.ASM
; PIC16F628
;**********************************************
; жϷ
ISR
		movwf	SaveWReg		; жֳ
		swapf	STATUS,W
		clrf	STATUS
		movwf	SaveStatus
		movf	PCLATH,W
		movwf	SavePCLATH

		btfsc	INTCON,T0IF		; did we get a TMR0 interrupt?
		goto	tmr0_svc		; yup
		
		btfsc	PIR1, TMR1IF		; got a TMR1 Int
		goto	tmr1_svc

		btfss	PIR1,RCIF		; ǷΪUSARTж
		goto	Err_Exit		; ! ˳
		movf	RCREG,w			; ! USART
		;movwf	TXREG			; תͻȥ
		movwf	RECREG
		;call	DUMP_232
		btfsc	RCSTA, FERR		; ǷFrame Error
		goto	FrameErr
		bsf	COMFLAG, 2
		call	SaveBuffer
		goto	Err_Exit
FrameErr	bsf	COMFLAG, 0		; FrameError bit
Err_Exit
		btfsc	PIR1,RCIF
		bcf	PIR1,RCIF		; USARTжϱ־
		btfsc	PIR1,TMR2IF
		bcf	PIR1,TMR2IF		; TMR2жϱ־
Restore_Exit
		movf	SavePCLATH,w
		movwf	PCLATH
		swapf	SaveStatus,W		; ָжֳ
		movwf	STATUS			; restore STATUS Reg
		swapf	SaveWReg,F		; save WREG
		swapf	SaveWReg,W		; restore WREG
		retfie				; жϷ

tmr1_svc
		bcf	PIR1,TMR1IF
		movlw	TMR1_HIGH
		movwf	TMR1H
		movlw	TMR1_LOW
		movwf	TMR1L
		
		decfsz	OffCount,f
		goto	Restore_Exit
		
		decfsz	OffTime,f
		goto	ResetOffCount
MyEnd
		call	LEDOFF
		bcf	STATUS, RP0
		bcf	T1CON, TMR1ON
		bsf	STATUS, RP0
		bcf	PIE1,	TMR1IE
		bcf	STATUS, RP0
		goto	Restore_Exit

ResetOffCount
		movlw	TMR1_COUNT
		movwf	OffCount
		goto	Restore_Exit

SetupTimeout
		movlw	TMR1_HIGH
		movwf	TMR1H
		movlw	TMR1_LOW
		movwf	TMR1L
		
		bcf	STATUS, RP0
		bcf	STATUS, C
		rlf	OffTime,f
		movlw	TMR1_COUNT
		movwf	OffCount
		bsf	T1CON, TMR1ON
		bsf	STATUS, RP0
		bsf	PIE1,	TMR1IE
		bcf	STATUS, RP0
		return
				
;**********************************************
; յַڻ
SaveBuffer
		movlw	RECVBUFF_SIZE		; С
		xorwf	RECVBUF_COUNT,w
		btfsc	STATUS,Z
		goto	SB_Exit			; ,Ƴ
		movlw	RECVBUFF_ADDR		; õǰдַ
		addwf	RECVBUF_COUNT,w
		movwf	FSR			; Set the indirect address
		movf	RCREG,w
		movwf	INDF			; Save the received char to buffer
		incf	RECVBUF_COUNT,f
SB_Exit		return

;**********************************************
; ӻȡһַܵ
ReadBuffer
		movlw	RECVBUFF_ADDR
		addwf	RECVBUF_READ_IDX,w
		movwf	FSR			; Set the indirect address
		movf	INDF,w			; Save the received char to buffer
		movwf	RECREG
		incf	RECVBUF_READ_IDX,f
		movf	RECVBUF_COUNT,w		; end of receive buffer?
		xorwf	RECVBUF_READ_IDX,w
		btfss	STATUS,Z
		goto	RB_Exit
		clrf	RECVBUF_READ_IDX
		clrf	RECVBUF_COUNT
RB_Exit		movf	RECREG,w
		return

;**********************************************
; һַ
GETCHAR
		;clrwdt
		movlw	0xff
		andwf	RECVBUF_COUNT,w		; check the buffer
		btfsc	STATUS,Z
		goto	scan
		call	ReadBuffer

		return


PUTCHAR
		MOVWF	ITMPW			;datasave
		BSF	STATUS,RP0		;switch to Bank1
LPTX
		clrwdt
		BTFSS	TXSTA,TRMT		;ready check
		GOTO	LPTX
;
		BCF	STATUS,RP0		;return to Bank0
		MOVF	ITMPW,W			;get data
		MOVWF	TXREG			;start send
		RETURN

	if _ClkIn == 20000000				; Clock = 20M
	if _BaudRate == 9600
SPBRG_SET	equ	.129			; 9600 bps
	else
SPBRG_SET	equ	.64			; 19200 bps
	endif
	else						; Clock = 10M
	if _BaudRate == 9600
SPBRG_SET	equ	.64			; 9600 bps
	else
SPBRG_SET	equ	.32			; 19200 bps
	endif
	endif

;**********************************************
; USARTʼ
InitUSART
		clrf	RECVBUF_COUNT		; 
		clrf	RECVBUF_READ_IDX	; 
		bsf	STATUS, RP0
		;clrf	TRISB			; PORTBȫԱLEDʾ
		;bsf	TRISB, DTR		; ϿRCģUSART TXŵϵ
		;bsf	TRISB, REC		; ϿRCģUSART RXŵϵ
		movlw	SPBRG_SET		; װزʷΪ9600Kbd
		movwf	SPBRG			; ڵƬʱΪ10MHzʱ
		movlw	b'00100100'		; ʹUSART,òʷΪٷʽ
		movwf	TXSTA
		bsf	PIE1,RCIE		; USARTĽж
		bcf	STATUS, RP0
		movlw	b'10010000'		; ʹUSART
		movwf	RCSTA			; ͬʱʹUSART˿
		bsf	INTCON,GIE		; ʹȫжʹλ
		bsf	INTCON,PEIE		; ʹжʹλ
		return

